import {
  GdsContainer
} from "./chunk.ZB4XIX5F.js";
import {
  styleExpressionProperty
} from "./chunk.ADPMTWTS.js";
import {
  tokens
} from "./chunk.LB64HYY2.js";
import {
  gdsCustomElement,
  html
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass
} from "./chunk.5VURDMKE.js";

// libs/core/src/components/layout/card/card.style.ts
import { css } from "lit";
var style = css`
  :host {
    display: block;
  }

  [backdrop] {
    inset: 0;
    z-index: -1;
    position: absolute;
    mask-size: cover;
    mask-repeat: no-repeat;
    mask-position: center;
  }

  [backdrop] + slot {
    z-index: 1;
  }
`;
var card_style_default = style;

// libs/core/src/components/layout/card/card.ts
var GdsCard = class extends GdsContainer {
  render() {
    return html`${this.mask || this.filter ? html`<div backdrop></div>` : ""}<slot></slot>`;
  }
};
GdsCard.styles = [tokens, card_style_default];
__decorateClass([
  styleExpressionProperty({
    property: "box-shadow",
    valueTemplate: (v) => `var(--gds-shadow-${v})`
  })
], GdsCard.prototype, "shadow", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => {
      const [size, color] = v.split("/");
      return `var(--gds-space-${size}) solid ${color ? `var(--gds-color-${color})` : "currentColor"}`;
    },
    styleTemplate: (_prop, values) => {
      const top = values[0];
      const right = values.length > 1 ? values[1] : top;
      const bottom = values.length > 2 ? values[2] : top;
      const left = values.length > 3 ? values[3] : top;
      return `border-top: ${top}; border-right: ${right}; border-bottom: ${bottom}; border-left: ${left};`;
    }
  })
], GdsCard.prototype, "border", 2);
__decorateClass([
  styleExpressionProperty({
    property: "border-radius",
    valueTemplate: (v) => `var(--gds-space-${v})`
  })
], GdsCard.prototype, "radius", 2);
__decorateClass([
  styleExpressionProperty({
    property: "backdrop-filter",
    selector: "[backdrop]",
    valueTemplate: (v) => `blur(${v})`
  })
], GdsCard.prototype, "filter", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => {
      const [position, colorName, transparency] = v.split("/");
      const color = transparency ? `color-mix(in srgb, var(--gds-color-${colorName}) ${parseFloat(transparency) * 100}%, transparent 0%)` : `var(--gds-color-${colorName})`;
      return `mask-image: linear-gradient(to ${position}, rgba(0, 0, 0, 1) 40%, rgba(0, 0, 0, 0) 100%); background-color: ${color};`;
    },
    styleTemplate: (_prop, values) => {
      const [MASK] = values[0].split("/");
      return `[backdrop] { ${MASK} }`;
    }
  })
], GdsCard.prototype, "mask", 2);
GdsCard = __decorateClass([
  gdsCustomElement("gds-card")
], GdsCard);

export {
  GdsCard
};
