// libs/core/src/components/calendar/functions.ts
import {
  startOfMonth,
  endOfMonth,
  addDays,
  eachWeekOfInterval,
  eachDayOfInterval
} from "date-fns";
import { html } from "lit";
function renderMonthGridView(date, template) {
  const monthStart = startOfMonth(date);
  const monthEnd = endOfMonth(date);
  const weeks = eachWeekOfInterval(
    { start: monthStart, end: monthEnd },
    { weekStartsOn: 1 }
  );
  return html`${template(
    weeks.map((weekStartDay) => ({
      days: eachDayOfInterval({
        start: weekStartDay,
        end: addDays(weekStartDay, 6)
      })
    }))
  )}`;
}

export {
  renderMonthGridView
};
