import {
  tokens
} from "./chunk.LB64HYY2.js";
import {
  gdsCustomElement
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass
} from "./chunk.5VURDMKE.js";

// libs/core/src/primitives/ripple/ripple.ts
import { LitElement, html, unsafeCSS } from "lit";
import { query } from "lit/decorators.js";

// libs/core/src/primitives/ripple/ripple.styles.scss?inline
var ripple_styles_default = `:host {
  --gds-ripple-motion-name: ripple;
  --gds-ripple-motion: var(--gds-ripple-motion-name)
    var(--gds-sys-motion-duration) var(--gds-sys-motion-timing-function)
    var(--gds-sys-motion-delay) var(--gds-sys-motion-iteration-count)
    var(--gds-sys-motion-direction) var(--gds-sys-motion-fill-mode)
    var(--gds-sys-motion-play-state);
  border-radius: var(--gds-space-max);
  contain: strict;
  display: flex;
  height: 100%;
  inset: 0;
  overflow: hidden;
  position: absolute;
  width: 100%;
}

div {
  background-color: currentColor;
  border-radius: var(--gds-space-max);
  display: flex;
  height: 20px;
  left: var(--gds-ripple-left, 50%);
  margin-left: -10px;
  margin-top: -10px;
  opacity: 0;
  pointer-events: none;
  position: absolute;
  top: var(--gds-ripple-top, 50%);
  width: 20px;
  will-change: transform;
}

div.gds-ripple-effect {
  animation: var(--gds-ripple-motion);
}

@keyframes ripple {
  from {
    opacity: 0.5;
    transform: scale(0);
  }
  to {
    opacity: 0;
    transform: scale(calc(3 * var(--mt-ripple-spread, 4)));
  }
}
@media (prefers-reduced-motion: reduce) {
  :host {
    --gds-ripple-motion-name: none !important;
  }
}`;

// libs/core/src/primitives/ripple/ripple.ts
var Ripple = class extends LitElement {
  constructor() {
    super(...arguments);
    this.onmousedown = (e) => {
      const target = e.target;
      const rect = target.getBoundingClientRect();
      const rippleEl = this._rippleEl;
      if (rippleEl) {
        rippleEl.classList.remove("gds-ripple-effect");
        this.style.setProperty("--gds-ripple-top", `${e.clientY - rect.top}px`);
        this.style.setProperty("--gds-ripple-left", `${e.clientX - rect.left}px`);
        setTimeout(() => {
          rippleEl.classList.add("gds-ripple-effect");
        }, 20);
      }
    };
  }
  render() {
    return html`<div></div>`;
  }
};
Ripple.styles = [tokens, unsafeCSS(ripple_styles_default)];
__decorateClass([
  query("div")
], Ripple.prototype, "_rippleEl", 2);
Ripple = __decorateClass([
  gdsCustomElement("gds-ripple")
], Ripple);

export {
  Ripple
};
