import {
  styleExpressionProperty
} from "./chunk.ADPMTWTS.js";
import {
  tokens
} from "./chunk.LB64HYY2.js";
import {
  GdsElement
} from "./chunk.ZQ4D5K7J.js";
import {
  gdsCustomElement
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass
} from "./chunk.5VURDMKE.js";

// libs/core/src/components/badge/badge.ts
import { html } from "lit/static-html.js";

// libs/core/src/components/badge/badge.style.ts
import { css } from "lit";
var style = css`
  @layer badge, shell, tokens, a11y, variants, types;

  @layer badge {
    :host {
      display: contents;
    }

    .badge {
      display: flex;
      align-items: center;
      justify-content: flex-start;
      font-size: var(--gds-text-size-detail-s);
      line-height: var(--gds-text-line-height-detail-s);
      background-color: var(--gds-color-l2c-background-information);
      padding-inline: var(--gds-space-xs);
      border-radius: var(--gds-space-2xs);
      block-size: var(--gds-space-l);
      gap: var(--gds-space-2xs);
      inline-size: max-content;
    }
  }
`;
var badge_style_default = style;

// libs/core/src/components/badge/badge.ts
var GdsBadge = class extends GdsElement {
  render() {
    return html`<div class="badge">
      <slot name="lead"></slot>
      <slot></slot>
      <slot name="trail"></slot>
    </div>`;
  }
};
GdsBadge.styles = [tokens, badge_style_default];
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `${v}`,
    selector: ".badge",
    styleTemplate: (prop, values) => {
      const variant = values[0];
      const variantMapping = {
        information: {
          bg: "information",
          color: "information"
        },
        notice: {
          bg: "notice",
          color: "notice"
        },
        success: {
          bg: "positive",
          color: "positive"
        },
        warning: {
          bg: "warning",
          color: "warning"
        },
        error: {
          bg: "negative",
          color: "negative"
        }
      };
      const tokens2 = variantMapping[variant] || {
        bg: "default-bg",
        color: "default-content"
      };
      const BG = `background-color: var(--gds-color-l3c-background-${tokens2.bg}-secondary);`;
      const CL = `color: var(--gds-color-l3c-content-${tokens2.color});`;
      const style2 = `${BG} ${CL}`;
      return style2;
    }
  })
], GdsBadge.prototype, "variant", 2);
GdsBadge = __decorateClass([
  gdsCustomElement("gds-badge")
], GdsBadge);

export {
  GdsBadge
};
