import {
  styleExpressionProperty
} from "./chunk.ADPMTWTS.js";
import {
  tokens
} from "./chunk.LB64HYY2.js";
import {
  GdsElement
} from "./chunk.ZQ4D5K7J.js";
import {
  gdsCustomElement,
  html
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass
} from "./chunk.5VURDMKE.js";

// libs/core/src/components/layout/container/container.style.ts
import { css } from "lit";
var style = css`
  :host {
    box-sizing: border-box;
  }
`;
var container_style_default = style;

// libs/core/src/components/layout/container/container.ts
var GdsContainer = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.display = "block";
  }
  render() {
    return html`<slot></slot>`;
  }
};
GdsContainer.styles = [tokens, container_style_default];
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "display", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => {
      const [colorName, transparency] = v.split("/");
      if (transparency) {
        return `color-mix(in srgb, var(--gds-sys-color-${colorName}) ${parseFloat(transparency) * 100}%, transparent 0%)`;
      } else {
        return `var(--gds-sys-color-${colorName})`;
      }
    }
  })
], GdsContainer.prototype, "color", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => {
      const [colorName, transparency] = v.split("/");
      if (transparency) {
        return `color-mix(in srgb, var(--gds-sys-color-${colorName}) ${parseFloat(transparency) * 100}%, transparent 0%)`;
      } else {
        return `var(--gds-color-${colorName})`;
      }
    }
  })
], GdsContainer.prototype, "background", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "opacity", 2);
__decorateClass([
  styleExpressionProperty()
], GdsContainer.prototype, "padding", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => {
      return v === "auto" ? "auto" : `var(--gds-space-${v})`;
    },
    styleTemplate: (_prop, values) => {
      const transformValue = (v) => v === "auto" ? "auto" : `${v}`;
      const top = transformValue(values[0]);
      const right = values.length > 1 ? transformValue(values[1]) : top;
      const bottom = values.length > 2 ? transformValue(values[2]) : top;
      const left = values.length > 3 ? transformValue(values[3]) : right;
      return `margin: ${top} ${right} ${bottom} ${left};`;
    }
  })
], GdsContainer.prototype, "margin", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "position", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "inset", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "overflow", 2);
__decorateClass([
  styleExpressionProperty({
    property: "grid-column",
    valueTemplate: (v) => `${v}`
  })
], GdsContainer.prototype, "column", 2);
__decorateClass([
  styleExpressionProperty({
    property: "grid-row",
    valueTemplate: (v) => `${v}`
  })
], GdsContainer.prototype, "row", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "height", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "width", 2);
__decorateClass([
  styleExpressionProperty({
    property: "z-index",
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "stack", 2);
__decorateClass([
  styleExpressionProperty({
    property: "box-sizing",
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "box", 2);
GdsContainer = __decorateClass([
  gdsCustomElement("gds-container")
], GdsContainer);

export {
  GdsContainer
};
