import { GdsElement } from '../../gds-element';
/**
 * @element gds-theme
 *
 * A component that provides CSS variables for a part of the DOM tree.
 * Every descendant of this component will inherit the CSS variables
 * provided by the theme set on this component.
 *
 * @slot - The content to apply the theme to.
 *
 * @status beta
 */
export declare class GdsTheme extends GdsElement {
    static styles: import("lit").CSSResult;
    /**
     * The theme mode. Can be `light`, `dark`, or `auto`.
     */
    colorScheme: 'light' | 'dark' | 'auto';
    connectedCallback(): void;
    render(): any;
    private _onColorSchemeChange;
}
